%P. Kano
%August 24, 2005
%[LaguerreCoef] = MWeeksMidPntLagCoef(Unitmatrix,Trianmatrix,NNodes,NLaguerreCoef,MInversions,SigmaWeeks,BetaWeeks)


function [LaguerreCoef] = MWeeksMidPntLagCoef(Unitmatrix,Trianmatrix,NNodes,NLaguerreCoef,MInversions,SigmaWeeks,BetaWeeks)

%Compute the Laguerre Coefficients
 LaguerreCoef(1:1:NNodes,1:1:NNodes,1:1:NLaguerreCoef) = 0;
 for j=-MInversions:1:(MInversions-1)
  Thetaj = j*pi/MInversions;
  Thetahalfj = (j+1/2)*pi/MInversions;
  Wtemp = exp(i*Thetahalfj);
  Stemp = SigmaWeeks-BetaWeeks+(2*BetaWeeks/(1-Wtemp)); 
  Gmatrix = (Stemp*eye(NNodes)-Trianmatrix)\eye(size(Trianmatrix));
  Gmatrix = (2*BetaWeeks/(1-Wtemp)).*Gmatrix;
  for n=1:1:NLaguerreCoef
   LaguerreCoef(:,:,n) = LaguerreCoef(:,:,n) + Gmatrix*exp(-1*i*(n-1)*Thetaj);
  end
 end
 
 for n=1:1:NLaguerreCoef
  LaguerreCoef(:,:,n) = LaguerreCoef(:,:,n)*exp(-1*i*(n-1)*pi/MInversions*1/2)/(2*MInversions);
 end
 

