%P. Kano
%November 8, 2005

function [SigmaWeeks,BetaWeeks,Unitmatrix,Trianmatrix,EstimatedTotalError] =...
MWeeksWeidemanParam(Amatrix,NLaguerreCoef,MInversions,LagSwitch,SigmaDistance,DeltaSigma,BetaMin,BetaMax,DeltaBeta)

NNodes = size(Amatrix,2); 

%Schur Decomposition
[Unitmatrix,Trianmatrix] = schur(full(Amatrix),'complex');

DiagVec = diag(Trianmatrix);
[SigmaMin,MaxRealPos] = max(real(DiagVec));

SigmaMax = SigmaMin + SigmaDistance;

if(SigmaMax<=SigmaMin) error('Maximum Sigma is less than the Minimum Sigma'); end

optnew = optimset('TolX',DeltaSigma);
[SigmaWeeks,EstimatedTotalError,ExitFlag,ExitOutput] =...
fminbnd('MWeeksWeidError',SigmaMin,SigmaMax,optnew,BetaMin,BetaMax,DeltaBeta,Unitmatrix,Trianmatrix,NNodes,NLaguerreCoef,MInversions,LagSwitch);

optnew = optimset('TolX',DeltaBeta);
[BetaWeeks,Rinverse,ExitFlag,ExitOutput] = fminbnd('WeeksMinBeta',BetaMin,BetaMax,optnew,SigmaWeeks,Trianmatrix);
