%P. Kano
%November 1, 2005

function [SigmaWeeks,BetaWeeks,Unitmatrix,Trianmatrix] =...
WeeksMinMaxGridParam(Amatrix,SigmaDistance,DeltaSigma,BetaMin,BetaMax,DeltaBeta)

%Schur Decomposition
[Unitmatrix,Trianmatrix] = schur(full(Amatrix),'complex');
DiagVec = diag(Trianmatrix);

%Parameter Ranges
[SigmaMin,MaxRealPos] = max(real(DiagVec));

SigmaMax = SigmaMin + SigmaDistance;

if(SigmaMax<=SigmaMin) error('Maximum Sigma is less than the Minimum Sigma'); end

SigmaVec = SigmaMin:DeltaSigma:SigmaMax;
BetaVec = BetaMin:DeltaBeta:BetaMax;

%Search
[X,Y,Z] = meshgrid(SigmaVec,BetaVec,DiagVec);
RSquared = abs(((Z-X-Y)./(Z-X+Y)).^2);

Rconvergence = min(RSquared,[],3); %Now a Function of Sigma and Beta

[Arow,Rowpos] = max(Rconvergence);
[Acol,Colpos] = max(Arow);
Rmax = Rconvergence(Rowpos(Colpos),Colpos);
SigmaWeeks = SigmaVec(Colpos);
BetaWeeks = BetaVec(Rowpos(Colpos));
